
public class HlavnáTrieda extends GRobot
{
    private class TrúchliváHlava extends Hlava
    {
        @Override public void smrť()
        {
            --skóre;
            super.smrť();

            if (odoberČlánok())
            {
                if (plošnáSmrť)
                {
                    GRobot hlavný = HlavnáTrieda.this;
                    hlavný.smer(hlava.smer());
                    hlavný.poloha(hlava.poloha());

                    int dĺžka = hadík.dĺžka();
                    for (int i = 1; i < dĺžka; ++i)
                    {
                        hlavný.dozadu(30);
                        hadík.daj(i).poloha(hlavný.poloha());
                    }

                    presuňSkóre();
                    hlavný.smer(90);
                }
                upravHadíka(true);
            }
        }
    }

    private final static Farba farbaPozadia = new Farba(110, 245, 135);

    private final Zoznam<ŽivýPrvok> hadík = new Zoznam<ŽivýPrvok>();
    private final Zoznam<ŽivýPrvok> zásoba = new Zoznam<ŽivýPrvok>();
    private final Zoznam<Jedlo> jedlá = new Zoznam<Jedlo>();

    private final Hlava hlava;

    private int skóre = 0;

    private boolean plošnáSmrť = false;
    private boolean automaticky = true;
    private boolean živéJedlo = true;
    private boolean svárlivéJedlo = true;
    private boolean reaktívneTelo = true;
    private boolean agresívnePožieranie = true;
    private boolean smrťHlave = false;

    private boolean zobrazSkóre = true;
    private boolean zobrazInformácie = false;
    private boolean celáObrazovka = false;

    private HlavnáTrieda()
    {
        super(Svet.šírkaZariadenia(0), Svet.výškaZariadenia(0));

        Svet.farbaPozadia(farbaPozadia);
        farba(tmavozelená);
        zdvihniPero();
        presuňSkóre();

        Svet.nekresli();

        hadík.pridaj(hlava = new TrúchliváHlava());
        for (int i = 0; i < 3; ++i)
            pridajČlánok();

        for (int i = 0; i < 150; ++i)
            jedlá.pridaj(new Jedlo());

        upravHadíka(true);
        reaktivujJedlá();

        hlava.aktivuj();
        Svet.kresli();

        new ObsluhaUdalostí()
        {
            @Override public void tik()
            {
                boolean zožralNiečo = false;

                for (Jedlo jedlo : jedlá)
                {
                    if (jedlo.koliduje(hlava))
                    {
                        zožralNiečo = true;
                        pridajČlánok();
                        jedlo.smrť();
                        ++skóre;
                    }
                }

                if (overKolízieTela()) zožralNiečo = true;
                if (svárlivéJedlo) presuňKolidujúceJedlá();
                upravHadíka(zožralNiečo);
            }

            @Override public void stlačenieKlávesu()
            {
                switch (ÚdajeUdalostí.kláves())
                {
                    case Kláves.VPRAVO:
                        hlava.uhlováRýchlosť(-30);
                        break;

                    case Kláves.VĽAVO:
                        hlava.uhlováRýchlosť(30);
                        break;

                    case Kláves.MEDZERA:
                        if (Svet.časovačAktívny())
                            Svet.zastavČasovač();
                        else
                            Svet.spustiČasovač();
                        break;

                    case Kláves.VK_A:
                        automaticky = !automaticky;
                        if (automaticky) smerNaJedlo();
                        else hlava.zrušCieľ(false);
                        if (zobrazInformácie &&
                            !Svet.časovačAktívny())
                            Svet.prekresli();
                        break;

                    case Kláves.VK_S:
                        svárlivéJedlo = !svárlivéJedlo;
                        if (svárlivéJedlo)
                            presuňKolidujúceJedlá();
                        if (zobrazInformácie &&
                            !Svet.časovačAktívny())
                            Svet.prekresli();
                        break;

                    case Kláves.VK_D:
                        zobrazInformácie =
                            !zobrazInformácie;
                        Svet.prekresli();
                        break;

                    case Kláves.VK_F:
                        živéJedlo = !živéJedlo;
                        reaktivujJedlá();
                        if (zobrazInformácie &&
                            !Svet.časovačAktívny())
                            Svet.prekresli();
                        break;

                    case Kláves.VK_G:
                        reaktívneTelo =
                            !reaktívneTelo;
                        overKolízieTela();
                        if (zobrazInformácie &&
                            !Svet.časovačAktívny())
                            Svet.prekresli();
                        break;

                    case Kláves.VK_H:
                        zobrazSkóre =
                            !zobrazSkóre;
                        Svet.prekresli();
                        break;

                    case Kláves.VK_J:
                        agresívnePožieranie =
                            !agresívnePožieranie;
                        if (zobrazInformácie &&
                            !Svet.časovačAktívny())
                            Svet.prekresli();
                        break;

                    case Kláves.VK_K:
                        plošnáSmrť = !plošnáSmrť;
                        if (zobrazInformácie &&
                            !Svet.časovačAktívny())
                            Svet.prekresli();
                        break;

                    case Kláves.VK_L:
                        smrťHlave = !smrťHlave;
                        if (zobrazInformácie &&
                            !Svet.časovačAktívny())
                            Svet.prekresli();
                        break;

                    case Kláves.VK_F11:
                        if (celáObrazovka)
                        {
                            if (Svet.celáObrazovka(false))
                                celáObrazovka = false;
                        }
                        else
                        {
                            if (Svet.celáObrazovka(true))
                                celáObrazovka = true;
                        }
                        break;
                }
            }

            @Override public void uvoľnenieKlávesu()
            {
                switch (ÚdajeUdalostí.kláves())
                {
                    case Kláves.VPRAVO:
                    case Kláves.VĽAVO:
                        hlava.uhlováRýchlosť(0);
                        break;
                }
            }

            @Override public void stlačenieTlačidlaMyši()
            {
                hlava.aktivuj();
                hlava.cieľNaMyš(true, false);
            }

            @Override public void ťahanieMyšou()
            {
                hlava.aktivuj();
                hlava.cieľNaMyš(true, false);
            }

            @Override public void zmenaVeľkostiOkna()
            {
                presuňSkóre();
            }
        };

        Svet.spustiČasovač(0.100);
    }

    private void presuňSkóre()
    {
        skočNa(Svet.ľavýOkraj() + 50,
            Svet.hornýOkraj() - 20);
    }

    private boolean odoberČlánok()
    {
        if (hadík.dĺžka() > 1)
        {
            ŽivýPrvok presuň = hadík.posledný();
            presuň.smrť();

            hadík.odober(presuň);
            zásoba.pridaj(presuň);
            return true;
        }

        return false;
    }

    private void pridajČlánok()
    {
        boolean nenájdené = true;

        if (zásoba.počet() > 0)
        {
            for (ŽivýPrvok presuň : zásoba)
            {
                if (presuň.skrytý())
                {
                    presuň.zobraz();

                    zásoba.odober(presuň);
                    hadík.pridaj(presuň);
                    nenájdené = false;
                    break;
                }
            }
        }

        if (nenájdené) hadík.pridaj(new ČlánokTela());

        if (hadík.počet() > 2)
        {
            ŽivýPrvok telo1 = hadík.daj(hadík.dĺžka() - 3);
            ŽivýPrvok telo2 = hadík.daj(hadík.dĺžka() - 2);
            ŽivýPrvok telo3 = hadík.daj(hadík.dĺžka() - 1);
            telo3.skočNa(telo2);
            telo3.otočNa(telo1);
            telo3.dozadu(30);
        }
    }

    private void smerNaJedlo()
    {
        int početJedál = jedlá.počet();
        Jedlo najbližšie = jedlá.daj(0);
        double vzdialenosť = hlava.vzdialenosťK(najbližšie);

        for (int i = 1; i < početJedál; ++i)
        {
            Jedlo jedlo = jedlá.daj(i);
            double porovnaj = hlava.vzdialenosťK(jedlo);

            if (porovnaj < vzdialenosť)
            {
                najbližšie = jedlo;
                vzdialenosť = porovnaj;
            }
        }

        hlava.cieľ(najbližšie, true, false);
    }

    private void upravHadíka(boolean ajVeľkosti)
    {
        int dĺžka = hadík.dĺžka();

        if (ajVeľkosti)
        {
            double veľkosťHlavy = hlava.veľkosť();
            double veľkosťChvosta = veľkosťHlavy / 2.0;
            double t = 0.0, Δt = 1.0 / (double)(dĺžka - 1);

            for (int i = 1; i < dĺžka; ++i)
            {
                hadík.daj(i).veľkosť(Svet.lineárnaInterpolácia(
                    veľkosťHlavy, veľkosťChvosta, t));
                t += Δt;
            }

            naVrch();

            if (automaticky) smerNaJedlo();
            else hlava.zrušCieľ(false);
        }

        for (int i = 1; i < dĺžka; ++i)
        {
            ŽivýPrvok článok0 = hadík.daj(i - 1);
            ŽivýPrvok článok1 = hadík.daj(i);
            článok1.otočNa(článok0);
            článok1.skočNa(článok0);
            článok1.dozadu(článok0.veľkosť() + článok1.veľkosť());
        }
    }

    private void presuňKolidujúceJedlá()
    {
        for (Jedlo jedlo : jedlá)
            for (ŽivýPrvok článok : hadík)
                if (jedlo.koliduje(článok))
                    jedlo.smrť();
    }

    private void reaktivujJedlá()
    {
        if (živéJedlo)
            for (Jedlo jedlo : jedlá)
                jedlo.aktivuj();
        else
            for (Jedlo jedlo : jedlá)
                jedlo.deaktivuj();
    }

    private boolean overKolízieTela()
    {
        int dĺžka2 = hadík.dĺžka();
        int dĺžka1 = reaktívneTelo ? dĺžka2 : 1;
        boolean zomrel = false;

        koniec:
        for (int i = 0; i < dĺžka1; ++i)
        {
            for (int j = i + 2; j < dĺžka2; ++j)
            {
                ŽivýPrvok článok1 = hadík.daj(i);
                ŽivýPrvok článok2 = hadík.daj(j);
                if (článok1.koliduje(článok2))
                {
                    if (agresívnePožieranie)
                    {
                        skóre -= dĺžka2 - j - 2;
                        for (int k = j + 1; k < dĺžka2; ++k)
                            odoberČlánok();
                    }

                    zomrel = true;
                    if (smrťHlave) hlava.smrť();

                    break koniec;
                }
            }
        }

        return zomrel;
    }

    @Override public void kresliTvar()
    {
        if (zobrazSkóre)
        {
            text("Skóre: " + skóre);
            zdvihniPero();
            dozadu(20);
        }

        if (zobrazInformácie)
        {
            String príznaky = "";

            if (automaticky) príznaky += "Au";
            if (živéJedlo) príznaky += "Ž";
            if (svárlivéJedlo) príznaky += "S";
            if (reaktívneTelo) príznaky += "R";
            if (agresívnePožieranie) príznaky += "Ag";
            if (plošnáSmrť) príznaky += "P";
            if (smrťHlave) príznaky += "H";

            if (!príznaky.isEmpty())
            {
                príznaky = "; " + príznaky;
                zdvihniPero();
                posuňVpravo(5 * príznaky.length());
            }

            text("(Dĺžka: " + hadík.dĺžka() + príznaky + ")");
        }
    }

    public static void main(String[] args)
    {
        Svet.použiKonfiguráciu();
        new HlavnáTrieda();
    }
}
